"use strict";

exports.__esModule = true;
var _exportNames = {
  documentRef: true,
  windowRef: true,
  EventListener: true,
  useEventListener: true
};
exports.windowRef = exports.useEventListener = exports.documentRef = exports.EventListener = void 0;

var _EventListener = require("./EventListener");

exports.EventListener = _EventListener.EventListener;

var _types = require("./types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _types[key]) return;
  exports[key] = _types[key];
});

var _useEventListener = require("./useEventListener");

exports.useEventListener = _useEventListener.useEventListener;
var documentRef = {
  current: typeof document === 'undefined' ? null : document
};
exports.documentRef = documentRef;
var windowRef = {
  current: typeof window === 'undefined' ? null : window
};
exports.windowRef = windowRef;
//# sourceMappingURL=index.js.map
