# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [v1.0.2](https://github.com/inspect-js/is-finalizationregistry/compare/v1.0.1...v1.0.2) - 2021-10-05

### Commits

- [meta] do not publish Github Actions workflows [`5509e8c`](https://github.com/inspect-js/is-finalizationregistry/commit/5509e8c13173a128244fc306d304c9be958b62f3)
- [actions] use `node/install` instead of `node/run`; use `codecov` action [`b566204`](https://github.com/inspect-js/is-finalizationregistry/commit/b5662048c9824089baf6fe3e0c408d6297635b2c)
- [readme] fix markdown [`02602dd`](https://github.com/inspect-js/is-finalizationregistry/commit/02602dda3176944f6681b97fb0d26e43bf2accc8)
- [Fix] use `call-bind` and obviate missing `es-abstract` dep [`9d71846`](https://github.com/inspect-js/is-finalizationregistry/commit/9d718467ef713e10242c28e48d82947d108ed5ef)
- [readme] add actions and codecov badges [`75381a7`](https://github.com/inspect-js/is-finalizationregistry/commit/75381a76ad373fd4bea0f032e8593dec60785332)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `auto-changelog`, `object-inspect`, `tape` [`7a0f9d8`](https://github.com/inspect-js/is-finalizationregistry/commit/7a0f9d8befeee03f578cf9184190e4a143a05abf)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `aud`, `object-inspect`, `tape` [`962689f`](https://github.com/inspect-js/is-finalizationregistry/commit/962689f01c33d06eadb4456004d231b56cb13825)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `tape` [`762ebf2`](https://github.com/inspect-js/is-finalizationregistry/commit/762ebf2f8d06597029b794053f0630b6ddeb7cc2)
- [meta] add `safe-publish-latest`; use `prepublishOnly` script for npm 7+ [`fe0b226`](https://github.com/inspect-js/is-finalizationregistry/commit/fe0b2268e0eaa4fd56418aba87d2e761c04917e6)

## [v1.0.1](https://github.com/inspect-js/is-finalizationregistry/compare/v1.0.0...v1.0.1) - 2020-12-04

### Commits

- [Tests] migrate tests to Github Actions [`b697250`](https://github.com/inspect-js/is-finalizationregistry/commit/b69725063681eeb9179d9945512a62112b360cd2)
- [Tests] run `nyc` on all tests [`9091806`](https://github.com/inspect-js/is-finalizationregistry/commit/9091806c8cc05340dc964fb3c566e650c1bff947)
- [actions] add "Allow Edits" workflow [`5d8c4f5`](https://github.com/inspect-js/is-finalizationregistry/commit/5d8c4f5e5ca4f001f6a16744c2cce5d32bdae39b)
- [Dev Deps] update `eslint`, `@ljharb/eslint-config`, `aud`, `auto-changelog`, `object-inspect` [`3af34c1`](https://github.com/inspect-js/is-finalizationregistry/commit/3af34c194a8dfb41e773f7e1647e1e1cf05ec98d)
- [actions] switch Automatic Rebase workflow to `pull_request_target` event [`d0720ff`](https://github.com/inspect-js/is-finalizationregistry/commit/d0720ff2d07308ec3e90f13c7a15affa05339fe7)
- [readme] remove travis badge [`2757b27`](https://github.com/inspect-js/is-finalizationregistry/commit/2757b27db4cbb93d712bd85c1741f3071a720dc7)
- [meta] add `package.json` to `exports` [`c680142`](https://github.com/inspect-js/is-finalizationregistry/commit/c680142dcd73d3f3c8ec75c0ab1c9281edaeb91f)

## v1.0.0 - 2020-08-02

### Commits

- Initial commit [`094a595`](https://github.com/inspect-js/is-finalizationregistry/commit/094a59522ab29b1701ad2f1cb67ee01f1e68cae2)
- readme [`38d75fd`](https://github.com/inspect-js/is-finalizationregistry/commit/38d75fd9d38106b6a4d09bdb4ac5c5ca186c62de)
- Tests [`1052cd2`](https://github.com/inspect-js/is-finalizationregistry/commit/1052cd21bfa90e83e5fbf656ce67f3c038aa9336)
- npm init [`307016d`](https://github.com/inspect-js/is-finalizationregistry/commit/307016d5228e184a22a1ee2992f24ed208c3cec6)
- Implementation [`48df57a`](https://github.com/inspect-js/is-finalizationregistry/commit/48df57a25d3cde99f43a46fe458e878f79179520)
- [meta] add auto-changelog [`cd1c8e1`](https://github.com/inspect-js/is-finalizationregistry/commit/cd1c8e1f97a499a0ea7edc6e7afde3b522fb8329)
- [actions] add automatic rebasing / merge commit blocking [`d6c9220`](https://github.com/inspect-js/is-finalizationregistry/commit/d6c92207d7f76785dada19e09b937326dc3b499d)
- [meta] add "funding"; create `FUNDING.yml` [`0e74e10`](https://github.com/inspect-js/is-finalizationregistry/commit/0e74e10f3667b1f8c9ea2a7a3dba67b373a17902)
- [Tests] add `npm run lint` [`edb8d13`](https://github.com/inspect-js/is-finalizationregistry/commit/edb8d138a6350b0fb7f398657125c74f218c547f)
- [Tests] use shared travis-ci configs [`8eb7a3a`](https://github.com/inspect-js/is-finalizationregistry/commit/8eb7a3a0a45e5aab60edb385ddee2e7bd1e22d81)
- Only apps should have lockfiles [`566b021`](https://github.com/inspect-js/is-finalizationregistry/commit/566b021e66bc2325e12f88324174413348cb987d)
